diff --git a/contrib/impcap/eth_parser.c b/contrib/impcap/eth_parser.c
index 67e99615be..4bda2d5c43 100644
--- a/contrib/impcap/eth_parser.c
+++ b/contrib/impcap/eth_parser.c
@@ -168,7 +168,7 @@ data_ret_t *eth_parse(const uchar *packet, int pktSize, struct json_object *jpar
 
 	json_object_object_add(jparent, "ETH_type", json_object_new_int(ethType));
 	json_object_object_add(jparent, "ETH_typestr", json_object_new_string((char *)eth_type_to_string(ethType)));
-	ret = (*ethProtoHandlers[ethType])((packet + hdrLen), (pktSize - hdrLen), jparent);
+	ret = eth_proto_parse(ethType, (packet + hdrLen), (pktSize - hdrLen), jparent);
 
 	/* packet has the minimum allowed size, so the remaining data is
 	 * most likely padding, this should not appear as data, so remove it */
diff --git a/contrib/impcap/impcap.c b/contrib/impcap/impcap.c
index f794ad863c..cdb1e540ac 100644
--- a/contrib/impcap/impcap.c
+++ b/contrib/impcap/impcap.c
@@ -78,11 +78,6 @@ DEFobjCurrIf(datetime)
 
 static prop_t *pInputName = NULL;
 
-/* --- init prototypes --- */
-void init_eth_proto_handlers(void);
-
-void init_ip_proto_handlers(void);
-
 char *stringToHex(char *string, size_t length);
 
 static ATTR_NORETURN void *startCaptureThread(void *instanceConf);
@@ -255,12 +250,6 @@ BEGINsetModCnf
 	int i;
 
 CODESTARTsetModCnf
-
-	/* TODO: find a better place for this */
-	init_ip_proto_handlers();
-
-	init_eth_proto_handlers();
-
 	pvals = nvlstGetParams(lst, &modpblk, NULL);
 	if (pvals == NULL) {
 		LogError(0, RS_RET_MISSING_CNFPARAMS, "impcap: error processing module "
@@ -368,7 +357,7 @@ ENDactivateCnfPrePrivDrop
 
 BEGINactivateCnf
 	instanceConf_t *inst;
-	pcap_t *dev;
+	pcap_t *dev = NULL;
 	struct bpf_program filter_program;
 	bpf_u_int32 SubNet, NetMask;
 	char errBuf[PCAP_ERRBUF_SIZE];
@@ -480,6 +469,7 @@ CODESTARTactivateCnf
 				else if (pcap_setfilter(dev, &filter_program)) {
 					LogError(0, RS_RET_LOAD_ERROR, "pcap: error while setting filter: '%s'",
 							 pcap_geterr(dev));
+					pcap_freecode(&	filter_program);
 					ABORT_FINALIZE(RS_RET_LOAD_ERROR);
 				}
 				pcap_freecode(&filter_program);
@@ -501,6 +491,9 @@ CODESTARTactivateCnf
 	}
 
 finalize_it:
+	if(iRet != 0) {
+		if(dev) pcap_close(dev);
+	}
 ENDactivateCnf
 
 BEGINfreeCnf
@@ -524,49 +517,6 @@ ENDfreeCnf
 
 /* runtime functions */
 
-/*
- *  Mock function to do no parsing when protocol is not a valid number
-*/
-data_ret_t *dont_parse(const uchar *packet, int pktSize, __attribute__((unused)) struct json_object *jparent) {
-	DBGPRINTF("protocol not handled\n");
-	RETURN_DATA_AFTER(0)
-}
-
-/*
- *  Initializes the function pointers' list for handled protocols
- *  contained within Ethernet II
-*/
-void init_eth_proto_handlers(void) {
-	DBGPRINTF("begining init eth handlers\n");
-	// set all to blank function
-	for (int i = 0; i < ETH_PROTO_NUM; ++i) {
-		ethProtoHandlers[i] = dont_parse;
-	}
-
-	ethProtoHandlers[ETHERTYPE_IP] = ipv4_parse;
-	ethProtoHandlers[ETHERTYPE_ARP] = arp_parse;
-	ethProtoHandlers[ETHERTYPE_REVARP] = rarp_parse;
-	ethProtoHandlers[ETHERTYPE_IPV6] = ipv6_parse;
-	ethProtoHandlers[ETHERTYPE_IPX] = ipx_parse;
-
-}
-
-/*
- *  Initializes the function pointers' list for handled protocols
- *  contained within IP
-*/
-void init_ip_proto_handlers(void) {
-	DBGPRINTF("begining init ip handlers\n");
-	// set all to blank function
-	for (int i = 0; i < IP_PROTO_NUM; ++i) {
-		ipProtoHandlers[i] = dont_parse;
-	}
-
-	ipProtoHandlers[IPPROTO_ICMP] = icmp_parse;
-	ipProtoHandlers[IPPROTO_TCP] = tcp_parse;
-	ipProtoHandlers[IPPROTO_UDP] = udp_parse;
-}
-
 /*
  *  Converts a list of bytes to their hexadecimal representation in ASCII
  *
diff --git a/contrib/impcap/ipv4_parser.c b/contrib/impcap/ipv4_parser.c
index ece98efb71..2693c60578 100644
--- a/contrib/impcap/ipv4_parser.c
+++ b/contrib/impcap/ipv4_parser.c
@@ -97,5 +97,5 @@ data_ret_t *ipv4_parse(const uchar *packet, int pktSize, struct json_object *jpa
 	json_object_object_add(jparent, "IP_proto", json_object_new_int(ipv4_header->proto));
 
 
-	return (*ipProtoHandlers[ipv4_header->proto])((packet + hdrLen), (pktSize - hdrLen), jparent);
+	return ip_proto_parse(ipv4_header->proto, (packet + hdrLen), (pktSize - hdrLen), jparent);
 }
diff --git a/contrib/impcap/llc_parser.c b/contrib/impcap/llc_parser.c
index 76685c2c2b..fca4568e3b 100644
--- a/contrib/impcap/llc_parser.c
+++ b/contrib/impcap/llc_parser.c
@@ -94,7 +94,7 @@ data_ret_t *llc_parse(const uchar *packet, int pktSize, struct json_object *jpar
 						   packet[headerLen + 4];
 		json_object_object_add(jparent, "SNAP_oui", json_object_new_int(orgCode));
 		json_object_object_add(jparent, "SNAP_ethType", json_object_new_int(ethType));
-		return (*ethProtoHandlers[ethType])(packet + headerLen, pktSize - headerLen, jparent);
+		return eth_proto_parse(ethType, packet + headerLen, pktSize - headerLen, jparent);
 	}
 	if (dsap == 0x06 && ssap == 0x06 && ctrl == 0x03) {
 		/* IPv4 header */
diff --git a/contrib/impcap/parsers.h b/contrib/impcap/parsers.h
index 3e2bcc451d..9f365298ab 100644
--- a/contrib/impcap/parsers.h
+++ b/contrib/impcap/parsers.h
@@ -61,9 +61,6 @@
 #ifndef INCLUDED_PARSER_H
 #define INCLUDED_PARSER_H 1
 
-#define IP_PROTO_NUM 256
-#define ETH_PROTO_NUM 0x9000
-
 /* data return structure */
 struct data_ret_s {
 	size_t size;
@@ -71,9 +68,16 @@ struct data_ret_s {
 };
 typedef struct data_ret_s data_ret_t;
 
-data_ret_t *(*ipProtoHandlers[IP_PROTO_NUM])(const uchar *packet, int pktSize, struct json_object *jparent);
-
-data_ret_t *(*ethProtoHandlers[ETH_PROTO_NUM])(const uchar *packet, int pktSize, struct json_object *jparent);
+#define RETURN_DATA_AFTER(x)    data_ret_t *retData = malloc(sizeof(data_ret_t)); \
+	if(pktSize > x) { \
+		retData->size = pktSize - x;  \
+		retData->pData = (char *)packet + x;  \
+	} \
+	else {  \
+		retData->size = 0;  \
+		retData->pData = NULL;  \
+	} \
+	return retData; \
 
 /* --- handlers prototypes --- */
 void packet_parse(uchar *arg, const struct pcap_pkthdr *pkthdr, const uchar *packet);
@@ -98,8 +102,6 @@ data_ret_t *arp_parse(const uchar *packet, int pktSize, struct json_object *jpar
 
 data_ret_t *rarp_parse(const uchar *packet, int pktSize, struct json_object *jparent);
 
-data_ret_t *dont_parse(const uchar *packet, int pktSize, struct json_object *jparent);
-
 data_ret_t *ah_parse(const uchar *packet, int pktSize, struct json_object *jparent);
 
 data_ret_t *esp_parse(const uchar *packet, int pktSize, struct json_object *jparent);
@@ -112,15 +114,43 @@ data_ret_t *http_parse(const uchar *packet, int pktSize, struct json_object *jpa
 
 data_ret_t *dns_parse(const uchar *packet, int pktSize, struct json_object *jparent);
 
-#define RETURN_DATA_AFTER(x)    data_ret_t *retData = malloc(sizeof(data_ret_t)); \
-	if(pktSize > x) { \
-		retData->size = pktSize - x;  \
-		retData->pData = (char *)packet + x;  \
-	} \
-	else {  \
-		retData->size = 0;  \
-		retData->pData = NULL;  \
-	} \
-	return retData; \
+/*
+ *  Mock function to do no parsing when protocol is not a valid number
+*/
+inline data_ret_t *dont_parse(const uchar *packet, int pktSize, __attribute__((unused)) struct json_object *jparent) {
+	DBGPRINTF("protocol not handled\n");
+	RETURN_DATA_AFTER(0)
+}
+
+// proto code handlers
+inline data_ret_t *eth_proto_parse(uint16_t ethProto, const uchar *packet, int pktSize, struct json_object *jparent) {
+	switch(ethProto) {
+		case ETHERTYPE_IP:
+			return ipv4_parse(packet, pktSize, jparent);
+		case ETHERTYPE_IPV6:
+			return ipv6_parse(packet, pktSize, jparent);
+		case ETHERTYPE_ARP:
+			return arp_parse(packet, pktSize, jparent);
+		case ETHERTYPE_REVARP:
+			return rarp_parse(packet, pktSize, jparent);
+		case ETHERTYPE_IPX:
+			return ipx_parse(packet, pktSize, jparent);
+		default:
+			return dont_parse(packet, pktSize, jparent);
+	}
+}
+
+inline data_ret_t *ip_proto_parse(uint16_t ipProto, const uchar *packet, int pktSize, struct json_object *jparent) {
+	switch(ipProto) {
+		case IPPROTO_TCP:
+			return tcp_parse(packet, pktSize, jparent);
+		case IPPROTO_UDP:
+			return udp_parse(packet, pktSize, jparent);
+		case IPPROTO_ICMP:
+			return icmp_parse(packet, pktSize, jparent);
+		default:
+			return dont_parse(packet, pktSize, jparent);
+	}
+}
 
 #endif /* INCLUDED_PARSER_H */
diff --git a/tests/bug_ether.pcap b/tests/bug_ether.pcap
new file mode 100644
index 0000000000..c8743d3c94
Binary files /dev/null and b/tests/bug_ether.pcap differ
diff --git a/tests/impcap_bug_ether.sh b/tests/impcap_bug_ether.sh
new file mode 100755
index 0000000000..9e433f0278
--- /dev/null
+++ b/tests/impcap_bug_ether.sh
@@ -0,0 +1,25 @@
+#!/bin/bash
+# added 2020-06-30 by frikilax
+# This file is part of the rsyslog project, released under ASL 2.0
+. ${srcdir:=.}/diag.sh init
+source ${srcdir:-.}/impcap.sh
+
+generate_conf
+add_conf '
+module(load="../contrib/impcap/.libs/impcap")
+
+template(name="impcap" type="string" string="%$!impcap%\n")
+
+input(type="impcap" file="'${srcdir}/bug_ether.pcap'")
+action(type="omfile" file="'$RSYSLOG_OUT_LOG'" template="impcap")
+'
+
+startup
+
+shutdown_when_empty
+wait_shutdown
+
+# Check for the intended parsing of the packet in wrong_ethtype.cap
+content_check '{ "ID": 1, "timestamp": "2020-06-30T17:07:25.980151+00:00", "net_bytes_total": 14, "ETH_src": "0:0:0:0:0:0", "ETH_dst": "ff:ff:ff:ff:ff:ff", "ETH_type": 36865, "ETH_typestr": "UNKNOWN", "net_bytes_data": 0 }'
+
+exit_test
diff --git a/tests/impcap_bug_ether_vg.sh b/tests/impcap_bug_ether_vg.sh
new file mode 100755
index 0000000000..b249faca99
--- /dev/null
+++ b/tests/impcap_bug_ether_vg.sh
@@ -0,0 +1,5 @@
+#!/bin/bash
+# added 2019-12-28 by frikilax
+# This file is part of the rsyslog project, released under ASL 2.0
+export USE_VALGRIND="YES"
+source ${srcdir:-.}/impcap_bug_ether.sh
\ No newline at end of file
